
#SCRIPT BSC V1.0

import pandas as pd
import numpy as np
from netmiko import ConnectHandler
from netmiko.ssh_exception import AuthenticationException
from netmiko.ssh_exception import NetMikoTimeoutException

##############################
###Definiciona de Variables###
##############################

variables_input = ('C:/_rlealuri_/script_bsc_outputs/variables_input.csv') #ruta de archivo de equipos a usar
shows_outputs = ('C:/_rlealuri_/script_bsc_outputs/shows_outputs/') #Ruta para guardar los archivos txt, i es ip del equipo, se guarda un archivo por cada equipo
configs_outputs = ('C:/_rlealuri_/script_bsc_outputs/configs_outputs/')
log_outputs = ('C:/_rlealuri_/script_bsc_outputs/log_outputs/log_outputs.txt') #Ruta para guardar log de conexiones SSH

#Variables para conexin a equipos
comandos = () #lista vaca a almacenar comandos a ejecutar
equipos = () #lista vaca a almacenar IPs de CSV
send_confs = () #lista vaca a almacenar con comandos de configuraciones
#username = 'admin'
#password = 'cisco!123'
#device_type = 'cisco_nxos'

###Leer csv y crear variable equipos
##no se ocupa ##colnames = ['ip', 'comandos', 'send_confs'] #se puede agregar otros nombres de columnas -colnames = ['ip', 'hostnames']-
df = pd.read_csv(variables_input, usecols=['ip', 'shows_commands', 'config_commands', 'username', 'password', 'device_type'], engine = 'python')
equipos  = df['ip'].dropna().tolist()
comandos = df['shows_commands'].dropna().tolist()
send_confs = df['config_commands'].dropna().tolist()
username = df.iloc[0,3] 
password = df.iloc[0,4]  
device_type = df.iloc[0,5] 


print(type(send_confs))
print(comandos)
print(send_confs)

###TERMINA####################
###Definiciona de Variables###
##############################

#OPCION : 1
###Mandar comandos shows a cada equipo de lista y guardarlo en ruta de variable ruta_bk_txt

#Inicia conexin a equipos con manejo de errores y creacin de log de conexiones
print(device_type)
print(equipos)
print(username)
print(password)

with open(log_outputs, 'w') as log_ssh: 
    for i in equipos: # puede ser all_nexus
        try:
                net_connect = ConnectHandler(device_type = device_type,
                                            ip = i,
                                            username = username,
                                            password = password) 
        except (NetMikoTimeoutException):
                print('Time Out: ' + i)
                log_ssh.write('Time Out: ' + i)
                log_ssh.write("\n")
                continue
        except Exception as unknown_error:
                print('Some other error: '  + i)
                log_ssh.write('Some other error: '  + i)
                log_ssh.write("\n")
                continue
        print("Conexion SSH " + i + ' exitosa')
        log_ssh.write("Conexion SSH : " + i + '\n')
       #continue                                                    #descomentar continue para solo hacer log conexion SSH 
#Inicia captura de comandos shows
        if comandos != []:
            with open(shows_outputs + i + '.txt', 'w') as f:
                for x in comandos:
                    output = net_connect.send_command(x)
                    print(x)    
                    f.write(output)
                   #Creacin de shows por separado
                    with open(shows_outputs + i + '_' + x.replace('/', '-').replace('|', '-') + '.txt', 'w') as shows_split: #x.replace remplaza string
                        shows_split.write(output)
                    print("*Shows guardados Finalizado*")
        else:
            print('*Sin shows a ejecutar*')
        
#Inicia envio de comandos de configuracin
        if send_confs != []:
            with open(configs_outputs + 'Log_Configs_Aplicadas_' + i + '.txt', 'w') as f:
                for x in send_confs:
                    output = net_connect.send_config_set(x)
                    print(x)    
                    f.write(output)
            print('*Configuraciones aplicadas y logs "Log_Configs_Aplicadas" guardadas*')
        else:   
            print('*Sin configuraciones a enviar*')
    log_ssh.write('*Log finalizado, termino lista de equipos y fin de script*')
    print('**Log finalizado, termino lista de equipos y fin de script**')
    